#pragma once

#include "hittable.h"

#include <memory>
#include <vector>

class hittable_list : public hittable
{
    public:
        hittable_list() {}
        hittable_list(std::shared_ptr<hittable> object) { add(object); }

        void clear() { objects_.clear(); }
        void add (std::shared_ptr<hittable> object) { objects_.push_back(object); }

        virtual bool hit(const ray& r, double t_min, double t_max,hit_record& rec) const;

    private:
        std::vector<std::shared_ptr<hittable>> objects_;
};

